Pas51_Rel_Part  SEGMENT CODE
        RSEG Pas51_Rel_Part
;PROGRAM Demo;
;(* This program is designed for an 87C750.
;	 It uses the following pins:-
;	 P1.5 				=>	serial input
;	 P1.6 				=>	serial output
;	 P3.0...P3.6	=>	dip switches giving a circuit board address
;	 P0.0 				=>	multiplexer 1 switch
;	 P0.1 				=>	multiplexer 2 switch
;	 P1.0 				=>	serial A to D Clock
;	 P1.1 				=>	serial A to D Data
;	 P1.2 				=>	serial A to D Start conversion
;
;	 Since the 87C750 does not have a UART the serial comm's is done in
;  the software. Xtal = 12MHz
;
;*)
;
;CONST
;  HiBaudVal  = 242;  (* (65536 - 3333 + 1) DIV 256 *)
;  LowBaudVal = 252;  (* (65536 - 3333 + 1) MOD 256 *)
;  HalfBitHi  = 249;  (* (65536 - 1667 + 1) DIV 256 *)
;  HalfBitLow = 126;  (* (65536 - 1667 + 1) MOD 256 *)
;
;VAR
;	(* start data after first 2 register banks...interrupt proc's switch
;		 to bank 2 *)
;
;	TxChar			at 16 : internal Byte; (* char to transmit *)
;	RxChar			at 17 : internal Byte; (* char recieved *)
;	BitCount		at 18 : internal Byte; (* the number of bits sent or recieved *)
;	CardAddress at 19 : internal Byte; (* set by dip switches *)
;	i 					at 20 : internal Byte; (* counter used in A/D *)
;	j 					at 21 : internal Byte; (* counter used in A/D *)
;	Total 			at 22 : internal Word; (* sum of 16 A/D conversions *)
;	Data				at 24 : internal Word; (* result of a to d *)
;
;
;	Transmitting at 0 : internal Bit;  (* true if transmitting *)
;	Receiving 	 at 1 : internal Bit;  (* true if receiving *)
;	GotChar 		 at 2 : internal Bit;  (* true if all bits are received *)
;
;	(* Serial in and out pins *)
;  TxOut at $96 : Bit;         (* P1.6 *)
;  RxIn  at $95 : Bit;         (* p1.5 *)
;
;  (* A/D pins *)
;  Clock  at $90 : Bit;        (* P1.0 *)
;  DataIn at $91 : Bit;        (* P1.1 *)
;  R_C    at $92 : Bit;        (* P1.2 *)
;
;  (* input selection pins *)
;  MainSwitch at $80 : Bit;    (* P0.0 *)
;  FreqSwitch at $81 : Bit;    (* P0.1 *)
;
;  (* define the registers I will be using *)
; P0	 at $80 : internal Byte;
;	P1	 at $90 : internal Byte;
;	P3	 at $B0 : internal Byte;
;	IE	 at $A8 : internal Byte;
;	TCON at $88 : internal Byte;
;	TL	 at $8A : internal Byte;
;	TH	 at $8C : internal Byte;
;	RTL  at $8B : internal Byte;
;	RTH  at $8D : internal Byte;
; SP	 at $81 : internal Byte;
; TR	 at $8C : Bit;
;
;
;(*------------------ Serial stuff --------------------*)
;
;interrupt PROCEDURE (Ext0);
;(* external interrupts on P1.5 *)
;(* to detect start bit only *)
;BEGIN
p51Ext0:
	PUSH	PSW
	PUSH	ACC
;*****	PUSH	B
;*****	PUSH	DPH
;*****	PUSH	DPL
;*****	PUSH	P2
	MOV	PSW,#08H
;	(* load with half bit time so we get to half way thru the bits *)
;  TH  := HalfBitHi; 
	MOV	8CH,#0F9H
;  TL  := HalfBitLow;
	MOV	8AH,#7EH
;
;  (* reload with the full bit time *)
;  RTH := HiBaudVal;
	MOV	8DH,#0F2H
;  RTL := LowBaudVal;
	MOV	8BH,#0FCH
;
;  (* start timer *)
;	TR := 1;
	SETB	8CH
;END;
;*****	POP P2
;*****	POP DPL
;*****	POP DPH
;*****	POP B
	POP	ACC
	POP	PSW
	RETI	
;
;
;interrupt PROCEDURE (Timer0);
;(* timer0 interrupt sets the bit time *)
;(* serial transmission is LSB first, MSB last *)
;BEGIN
p51Timer0:
	PUSH	PSW
	PUSH	ACC
;*****	dont need to save all this
;*****  PUSH  B
;*****	PUSH	DPH
;*****	PUSH	DPL
;*****	PUSH	P2
;*****	PUSH	10H
;*****	PUSH	11H
;*****	PUSH	12H
;*****	PUSH	13H
;*****	PUSH	14H
;*****	PUSH	15H
;*****	PUSH	16H
;*****	PUSH	17H
;*****	PUSH	2DH
;***** change PSW to 08H as well since both interrupts do not occur together
  MOV PSW,#08H
;	IF Transmitting = 1 THEN
	CLR	A
	JNB	00H,P51_0000
	INC	A
P51_0000:
;		BEGIN
	;;;	P51_0001
	JZ  	P51_0002
P51_0001:
;			BitCount := BitCount + 1;
	MOV	A,12H
	ADD	A,#01H
	MOV	12H,A
;			IF (TxChar AND 1) = 1 THEN
	MOV	A,10H
	ANL	A,#01H
	CLR	C
	SUBB	A,#01H
	JZ	P51_0003
	MOV	A,#0FFH
P51_0003:
	INC	A
;				TxOut := 1
	;;;	P51_0004
	JZ  	P51_0005
P51_0004:
;			ELSE
	SETB	96H
;				TxOut := 0;
	AJMP	P51_0006
P51_0005:
	CLR	96H
P51_0006:
;			TxChar := SHR(TxChar);		(* get next bit *)
	MOV	A,10H
	CLR	C
	RRC	A
	MOV	10H,A
;		END
;	ELSE
;		IF Receiving = 1 THEN
	AJMP	P51_0007
P51_0002:
	CLR	A
	JNB	01H,P51_0008
	INC	A
P51_0008:
;			BEGIN
	;;;	P51_0009
	JZ  	P51_000A
P51_0009:
;				IF RxIn = 1 THEN
	CLR	A
	JNB	95H,P51_000B
	INC	A
P51_000B:
;          RxChar := RxChar OR BitCount;
	;;;	P51_000C
	JZ  	P51_000D
P51_000C:
	MOV	A,11H
	ORL	A,12H
	MOV	11H,A
P51_000D:
;				IF BitCount = 128 THEN	(* we have all the bits *)
	MOV	A,12H
	CLR	C
	SUBB	A,#80H
	JZ	P51_000E
	MOV	A,#0FFH
P51_000E:
	INC	A
;					GotChar := 1;
	;;;	P51_000F
	JZ  	P51_0010
P51_000F:
	SETB	02H
P51_0010:
;				BitCount := SHL(BitCount);
	MOV	A,12H
	CLR	C
	RLC	A
	MOV	12H,A
;      END
;		ELSE									(* just started receiving *)
;			IF RxIn = 0 THEN		(* start bit still valid *)
	AJMP	P51_0011
P51_000A:
	CLR	A
	JB	95H,P51_0012
	INC	A
P51_0012:
;				BEGIN
	;;;	P51_0013
	JZ  	P51_0014
P51_0013:
;					IE := $82;			(* no more external interrupts *)
	MOV	0A8H,#82H
;					Receiving := 1; (* finished with start bit, now go on to get bits *)
	SETB	01H
;				END
;			ELSE
;				TR := 0;							(* not a valid start bit so stop timer *)
	AJMP	P51_0015
P51_0014:
	CLR	8CH
P51_0015:
P51_0011:
P51_0007:
;END;
;*****	POP 2DH
;*****	POP 17H
;*****	POP 16H
;*****	POP 15H
;*****	POP 14H
;*****	POP 13H
;*****	POP 12H
;*****	POP 11H
;*****	POP 10H
;*****	POP P2
;*****	POP DPL
;*****	POP DPH
;*****	POP B
	POP	ACC
	POP	PSW
	RETI	
;
;
;PROCEDURE Delay(i : Byte);
;BEGIN
delay:
;  REPEAT
;    i := i - 1;
P51_0016:
	MOV	A,SP
	ADD	A,#0FEH
	MOV	R0,A
	MOV	A,@R0
	CLR	C
	SUBB	A,#01H
	MOV	R2,A
	MOV	A,SP
	ADD	A,#0FEH
	MOV	R0,A
	MOV	@R0,02H
;  UNTIL i = 0;
	MOV	A,SP
	ADD	A,#0FEH
	MOV	R0,A
	MOV	A,@R0
	JZ	P51_0017
	MOV	A,#0FFH
P51_0017:
	INC	A
	;;;	P51_0018
	JZ  	P51_0016
P51_0018:
;END;
	POP	DPH
	POP	DPL
	MOV	A,SP
	ADD	A,#0FFH
	MOV	SP,A
	PUSH	DPL
	PUSH	DPH
	RET	 
;
;
;PROCEDURE LongDelay(i : Byte);
;BEGIN
longdelay:
;  REPEAT
;    Delay(255);
P51_0019:
	MOV	R0,#0FFH
	PUSH	00H
	ACALL	delay
;    i := i - 1;
	MOV	A,SP
	ADD	A,#0FEH
	MOV	R0,A
	MOV	A,@R0
	CLR	C
	SUBB	A,#01H
	MOV	R2,A
	MOV	A,SP
	ADD	A,#0FEH
	MOV	R0,A
	MOV	@R0,02H
;  UNTIL i = 0;
	MOV	A,SP
	ADD	A,#0FEH
	MOV	R0,A
	MOV	A,@R0
	JZ	P51_001A
	MOV	A,#0FFH
P51_001A:
	INC	A
	;;;	P51_001B
	JZ  	P51_0019
P51_001B:
;END;
	POP	DPH
	POP	DPL
	MOV	A,SP
	ADD	A,#0FFH
	MOV	SP,A
	PUSH	DPL
	PUSH	DPH
	RET	 
;
;
;PROCEDURE Transmit;
;BEGIN
transmit:
;  BitCount := 0;
	MOV	12H,#00H
;  TH  := HiBaudVal;
	MOV	8CH,#0F2H
;  TL  := LowBaudVal;
	MOV	8AH,#0FCH
;  RTH := HiBaudVal;
	MOV	8DH,#0F2H
;  RTL := LowBaudVal;
	MOV	8BH,#0FCH
;	IE := $82;							(* allow timer interrupts *)
	MOV	0A8H,#82H
;	Transmitting := 1;
	SETB	00H
;	TxOut := 0; 						(* start bit *)
	CLR	96H
;	TR := 1;								(* start counter *)
	SETB	8CH
;
;	REPEAT									(* loop while bits are being sent via the timer interrupt *)
;	UNTIL BitCount = 9; 		(* no more bits *)
P51_001C:
	MOV	A,12H
	CLR	C
	SUBB	A,#09H
	JZ	P51_001D
	MOV	A,#0FFH
P51_001D:
	INC	A
	;;;	P51_001E
	JZ  	P51_001C
P51_001E:
;
;	TR := 0;								(* stop counter *)
	CLR	8CH
;	Transmitting := 0;
	CLR	00H
;	TxOut := 1; 						(* idle value *)
	SETB	96H
;  IE := 0;                (* no more interrupts *)
	MOV	0A8H,#00H
;  Delay(255);
	MOV	R0,#0FFH
	PUSH	00H
	ACALL	delay
;END;
	RET	 
;
;
;PROCEDURE Receive;
;(* waits for a recieved character *)
;BEGIN
receive:
;  BitCount := 1;
	MOV	12H,#01H
;  RxChar := 0;
	MOV	11H,#00H
;	TR := 0;
	CLR	8CH
;	IE := $83;					 (* allow hardware and timer interrupt *)
	MOV	0A8H,#83H
;  
;	GotChar := 0;
	CLR	02H
;
;	REPEAT							 (* loop while bits are being received *)
;	UNTIL GotChar = 1;
P51_001F:
	CLR	A
	JNB	02H,P51_0020
	INC	A
P51_0020:
	;;;	P51_0021
	JZ  	P51_001F
P51_0021:
;  
;	TR := 0;						 (* stop timer *)
	CLR	8CH
;	IE := 0;						 (* no interrupts *)
	MOV	0A8H,#00H
;	Receiving := 0;
	CLR	01H
;  Delay(255);
	MOV	R0,#0FFH
	PUSH	00H
	ACALL	delay
;END;
	RET	 
;
;(*----------------- A to D stuff ------------------*)
;
;FUNCTION GetValue : Word;
;BEGIN
getvalue:
	MOV	A,SP
	ADD	A,#02H
	MOV	SP,A
;	Data := 0;
	MOV	18H,#00H
	MOV	19H,#00H
;	j := 1;
	MOV	15H,#01H
;	REPEAT
;		Clock := 1;
P51_0022:
	SETB	90H
;***** ad the NOP's to give a 5 microsecond delay
	NOP
	NOP
	NOP
	NOP
	NOP
;   Clock := 0;
	CLR	90H
;		Data := SHL(Data);
	MOV	A,18H
	CLR	C
	RLC	A
	XCH	A,B
	MOV	A,19H
	RLC	A
	XCH	A,B
	MOV	18H,A
	MOV	19H,B
;		IF DataIn = 1 THEN
	CLR	A
	JNB	91H,P51_0023
	INC	A
P51_0023:
;			Data := Data + 1;
	;;;	P51_0024
	JZ  	P51_0025
P51_0024:
	MOV	A,18H
	ADD	A,#01H
	XCH	A,B
	MOV	A,19H
	ADDC	A,#00H
	XCH	A,B
	MOV	18H,A
	MOV	19H,B
P51_0025:
;		j := j + 1;
	MOV	A,15H
	ADD	A,#01H
	MOV	15H,A
;	UNTIL j = 13;
	MOV	A,15H
	CLR	C
	SUBB	A,#0DH
	JZ	P51_0026
	MOV	A,#0FFH
P51_0026:
	INC	A
	;;;	P51_0027
	JZ  	P51_0022
P51_0027:
;  GetValue := Data;
	MOV	A,SP
	ADD	A,#0FFH
	MOV	R0,A
	MOV	@R0,18H
	INC	R0
	MOV	@R0,19H
;END;
	MOV	R0,SP
	MOV	B,@R0
;***** make sure the next instruction is DEC NOT INC
  DEC R0
	MOV	01H,@R0
	MOV	A,SP
	ADD	A,#0FEH
	MOV	SP,A
	MOV	A,R1
	RET	 
;
;
;PROCEDURE DoAtoD;
;(* MSB is clocked out first *)
;(* averages 16 readings *)
;BEGIN
doatod:
;  Total := 0;
	MOV	16H,#00H
	MOV	17H,#00H
;	i := 1;
	MOV	14H,#01H
;	REPEAT
;		(* start conversion *)
;		R_C := 0;
P51_0028:
	CLR	92H
; add a 5 microsecond delay
	NOP
	NOP
	NOP
	NOP
	NOP
;   R_C := 1;
	SETB	92H
;
;    Clock := 1;
	SETB	90H
; add a 5 microsecond delay
	NOP
	NOP
	NOP
	NOP
	NOP
;   Clock := 0;
	CLR	90H
;
;    Total := Total + GetValue;
	ACALL	getvalue
	ADD	A,16H
	XCH	A,B
	ADDC	A,17H
	XCH	A,B
	MOV	16H,A
	MOV	17H,B
;		Delay(10);
	MOV	R0,#0AH
	PUSH	00H
	ACALL	delay
;		i := i + 1;
	MOV	A,14H
	ADD	A,#01H
	MOV	14H,A
;	UNTIL i = 17;
	MOV	A,14H
	CLR	C
	SUBB	A,#11H
	JZ	P51_0029
	MOV	A,#0FFH
P51_0029:
	INC	A
	;;;	P51_002A
	JZ  	P51_0028
P51_002A:
;  Data := Total DIV 16;
	MOV	A,16H
	PUSH	ACC
	MOV	A,#10H
	PUSH	ACC
	MOV	A,17H
	XCH	A,B
	MOV	01H,#00H
	POP	00H
	POP	ACC
EXTRN CODE (DivWord_)
	ACALL	DivWord_
	MOV	18H,A
	MOV	19H,B
;END;
	RET	 
;
;
;PROCEDURE GetTemperature;
;(* of temperature sensor on board LM35 *)
;BEGIN
gettemperature:
;  MainSwitch := 1;
	SETB	80H
;	(* now wait for filter time constant *)
;  LongDelay(200);
	MOV	R0,#0C8H
	PUSH	00H
	ACALL	longdelay
;  DoAtoD;
	ACALL	doatod
;END;
	RET	 
;
;
;PROCEDURE GetCoating;
;BEGIN
getcoating:
;  MainSwitch := 0;
	CLR	80H
;  FreqSwitch := 1;
	SETB	81H
;	(* now wait for filter time constant *)
;  LongDelay(200);
	MOV	R0,#0C8H
	PUSH	00H
	ACALL	longdelay
;  DoAtoD;
	ACALL	doatod
;END;
	RET	 
;
;
;PROCEDURE GetDiameter;
;BEGIN
getdiameter:
;  MainSwitch := 0;
	CLR	80H
;  FreqSwitch := 0;
	CLR	81H
;	(* now wait for filter time constant *)
;  LongDelay(200);
	MOV	R0,#0C8H
	PUSH	00H
	ACALL	longdelay
;  DoAtoD;
	ACALL	doatod
;END;
	RET	 
;
;(*----------------------------------------------------------------------*)
;
;PROCEDURE Init;
;BEGIN
init:
;  (* set serial stuff *)
;	IE := 0;								 (* no interrupts at this point *)
	MOV	0A8H,#00H
;	TxOut := 1; 						 (* idle value *)
	SETB	96H
;	TCON := 4;							 (* setup the timer/counter *)
	MOV	88H,#04H
;	TR := 0;
	CLR	8CH
;	Transmitting := 0;
	CLR	00H
;	Receiving := 0;
	CLR	01H
;
;  MainSwitch := 0;
	CLR	80H
;  FreqSwitch := 1;
	SETB	81H
;  
;	P3 := 255;							 (* set high to use as inputs *)
	MOV	0B0H,#0FFH
;END;
	RET	 
;
;
;BEGIN       
demo:
	MOV	SP,#42H
	MOV	P2,#0
	MOV	PSW,#0
	MOV	2CH,#0
;	SP := $2F; (* to after bit data *)
	MOV	81H,#2FH
;  Init;
	ACALL	init
;	REPEAT
;		REPEAT
P51_002B:
;			CardAddress := P3 AND 127;
P51_002C:
	MOV	A,0B0H
	ANL	A,#7FH
	MOV	13H,A
;			Receive;
	ACALL	receive
;    UNTIL RxChar = CardAddress;        
	MOV	A,11H
	CLR	C
	SUBB	A,13H
	JZ	P51_002D
	MOV	A,#0FFH
P51_002D:
	INC	A
	;;;	P51_002E
	JZ  	P51_002C
P51_002E:
;		(* echo address *)
;    TxChar := RxChar;
	MOV	10H,11H
;		Transmit;
	ACALL	transmit
;
;		REPEAT
;      Receive;
P51_002F:
	ACALL	receive
;		UNTIL RxChar > 127; 	(* valid command *)
	MOV	A,11H
	CLR	C
	SUBB	A,#7FH
	JZ	P51_0030
	CLR	A
	JC	P51_0030
	INC	A
P51_0030:
	;;;	P51_0031
	JZ  	P51_002F
P51_0031:
;		(* echo command *)
;		TxChar := RxChar;
	MOV	10H,11H
;    Transmit;
	ACALL	transmit
;
;    (* all the actions set the global "Data" *)
;    CASE RxChar OF
;      255 : GetTemperature;
	MOV	A,11H
	CJNE	A,#0FFH,P51_0035
	JMP	P51_0034
P51_0035:
	JMP	P51_0033
P51_0034:
	ACALL	gettemperature
;      254 : GetCoating;
	JMP	P51_0032
P51_0033:
	CJNE	A,#0FEH,P51_0039
	JMP	P51_0038
P51_0039:
	JMP	P51_0037
P51_0038:
	ACALL	getcoating
;      253 : GetDiameter;
	JMP	P51_0032
P51_0037:
	CJNE	A,#0FDH,P51_003D
	JMP	P51_003C
P51_003D:
	JMP	P51_003B
P51_003C:
	ACALL	getdiameter
;    END;  
P51_003B:
P51_0032:
;    
;    (* now send result *)
;    TxChar := Lo(Data);
	MOV	A,18H
	MOV	10H,A
;    Transmit;                       
	ACALL	transmit
;		Delay(255);
	MOV	R0,#0FFH
	PUSH	00H
	ACALL	delay
;    TxChar := Hi(Data);
	MOV	A,19H
	MOV	10H,A
;    Transmit;
	ACALL	transmit
;
;  UNTIL False;
	JMP	P51_002B
;END.
	NOP	 
;---------------------------------------------
; ----- End Of Pascal51 Relocate Segment -----
;---------------------------------------------
           CSEG At 00H
        ORG 0      
;***** change from LJMP for small devices
				AJMP demo
;***** and make sure int' is at right place
        ORG 03H
  AJMP p51Ext0
        ORG 0BH    
	AJMP p51Timer0
        ;------    
        ;--------- 
        ;------    
        ;--------- 
        ;------    
        ;--------- 
NOISR:  RETI       
        ;--------  
	END	 
